#!/bin/ruby
#
# Author:
#   john [at] tinternet org uk
#
# Desc:
#   test script to run the ESX checking stuff
#
# Lisence:
#   see vim25.rb for lisence and copyright information
#

require 'vim25.rb'
include VMware

esxIP = ARGV[0]

srv = ESXServer.new(esxIP)
puts
puts
puts "getESXVersion()"
puts "---------------"
puts srv.getESXVersion
puts
puts 'login("username","password")'
puts "------------------------"
puts srv.login("username","password").returnval.key
puts

srv.setHostSystem
srv.setConninfo
srv.setConfigManager
srv.setRootFolder
srv.setDatacenter
srv.setDatastore

puts "listVMs()"
puts "---------"
puts srv.listVMs
puts
puts "getSessions()"
puts "-------------"
puts srv.getSessions
puts
puts "listUsers()"
puts "-----------"
puts srv.listUsers.to_s
puts
puts "getNonStandardUsers()"
puts "---------------------"
puts srv.getNonStandardUsers.to_s
puts
puts "listShellUsers()"
puts "----------------"
puts srv.listShellUsers.to_s
puts
puts "getHostname()"
puts "-------------"
puts srv.getHostname
puts
puts "dhcpEnabled?()"
puts "--------------"
puts srv.dhcpEnabled?
puts
puts "getSearchDomain()"
puts "-----------------"
puts srv.getSearchDomain
puts
puts "listDNSServers()"
puts "----------------"
puts srv.listDNSServers
puts
puts "listPnics()"
puts "-----------"
puts srv.listPnics
puts
puts "getConsoleNicInfo()"
puts "-------------------"
puts srv.getConsoleNicInfo
puts
puts "listPortgroups()"
puts "----------------"
puts srv.listPortgroups
puts
puts "checkInterfaceSecurity()"
puts "------------------------"
puts srv.checkInterfaceSecurity
puts
puts "getRuleset()"
puts "------------"
puts srv.getRuleset.to_s
puts
puts "checkConfig()"
puts "-------------"
puts srv.checkConfig
puts
puts "getApplicablePatches()"
puts "----------------------"
puts srv.getApplicablePatches.inspect
puts
puts "logout()"
puts "-------------"
puts srv.logout

puts "...finished"

