#!/usr/bin/ruby
#
# Author:
#   john [at] tinternet org uk
#
# Desc:
#   module to perform checks/actions against the firewall on ESX
#
# NOTE: 
#   ESXi does not support the same firewall managed object as ESXi
#
# Lisence:
#   see vim25.rb for lisence and copyright information


module Firewall

  #
  #
  # returns the firewall ruleset
  # NOTE: for some reason this is missing the port 80 out - why???
  def getRuleset

     fwProps = retrieveProperty(@configManager[0].propSet[4].val.firewallSystem,
                                true,
                                "HostFirewallSystem",
                                "firewallInfo",
                                true)

      # look through the ruleset and return it
      rulebase_ary = []
      if fwProps[0].propSet[1].val.defaultPolicy.incomingBlocked
        rulebase_ary << "Default deny (inbound)\n"
      else
        rulebase_ary << "WARN: no default deny inbound\n"
      end

      if fwProps[0].propSet[1].val.defaultPolicy.outgoingBlocked
        rulebase_ary << "Default deny (outbound)\n"
      else
        rulebase_ary << "WARN: no default deny outbound\n"
      end
      rulebase_ary << "------------------------\n"
      fwProps[0].propSet[1].val.ruleset.each do |rule|
        if rule.enabled
          ruleString = rule.rule[0].direction.to_s+"/"
          ruleString.concat(rule.rule[0].port.to_s+"/")
          ruleString.concat(rule.rule[0].protocol.to_s+"/")
          ruleString.concat(rule.service.to_s+"/")
          ruleString.concat(rule.label.to_s+"\n")
          rulebase_ary << ruleString
        end
      end

      return rulebase_ary

  end # end getRuleset



end # end Firewall module
