#!/usr/bin/ruby
#
# Author:
#   john [at] tinternet org uk
#
# Desc:
# module to perform checks/actions against the patch level of ESX
#
# Lisence:
#   see vim25.rb for lisence and copyright information

module Patching

  include Vim25

  def getApplicablePatches

    patchInfo = scanPatchesTask

    applicablePatches_ary = []
    patchInfo[0].propSet[0].val.each do |patch|
      if patch.applicable && !patch.installed
        applicablePatches_ary << patch
      end
    end

    # return an array of applicable patches
    return applicablePatches_ary

  end


  private

  #
  #
  # initiates the task that scans for patches. returns the task. does not check
  # to see if the task has completed
  def scanPatchesTask

      # TODO: this URL should be passed as an argument at some point
      patchLoc = HostPatchManagerLocator.new
      #
      patchLoc.url = "http://www.tinternet.org.uk/vmware/updates35/"
      # NOTE: chances are you won't have internet connectivity from the network on which your 
      #       VMware management interfaces sit so you won't be able to access this - it is probably
      # TODO: worth at some point implementing --update functionality which pulls all of this down,
      #       this can then run a local webserver which has the relevant information in it.

      morf = @configManager[0].propSet[4].val.patchManager

      reqType = ScanHostPatchRequestType.new(morf)
      reqType.repository = patchLoc
      reqType.updateID = ""

      task = @driver.scanHostPatch_Task(reqType)

      # TODO:
      # there has to be a better way of doing this than how i am doing it
      # but i cant find a method to query the status of a task so for now it'll
      # have to work this way.
      finished = 0
      while finished != 1

        status = retrieveProperty(task.returnval,
                                  true,
                                 "Task",
                                 "info.result",
                                 false)

        if (status[0].propSet != nil)
          finished = 1
          return status
        end
    end
  end

  #
  #
  # determines when a task completes - purely through polling until status is complete


end
